#!/usr/bin/php
<?
# sm.php version 1.03 10/07/09
/*
    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

# 
# local config
#

$ping_google_after_generate=0;	// set to 1 if you want to let search engines know about sitemap updates
$yahooid='';					// if you get an id from yahoo and put it here 


if ($argc<2) {
	echo "Usage: sitemap.php config.xml\n";
	exit(1);
}

$config=simplexml_load_file($argv[1]);
if ($config===false) {
	printf("config file parse error\n");
	exit;
}


$mapurl=$config['base_url'];
$basename=$config['store_into'];
if (substr($basename,strlen($basename)-7)=='.xml.gz')
	$basename=substr($basename,0,strlen($basename)-7);

$dirs=array();

foreach ($config->directory as $dir) {
	$dirs[]=array($dir['path'],$dir['url']);
}

foreach ($config->filter as $f) {
	$filters[]=array($f['action'],$f['type'],$f['pattern']);
	if (substr($f['pattern'],strlen($f['pattern'])-2)=='/*')
		$filters[]=array($f['action'],$f['type'],substr($f['pattern'],0,strlen($f['pattern'])-2));
}

#print_r($filters);
#exit;

$basedir=null;
$maphandle=null;
$mapnum=-1;
$mapcount=0;
$ignore=array();
$maps=array();


function writemap($p,$s) {
	global $mapcount,$mapnum,$maphandle;
	global $baseurl,$basedir,$basename,$maps;

	$hdr='<?xml version="1.0" encoding="UTF-8"?>
<urlset xmlns="http://www.sitemaps.org/schemas/sitemap/0.9">
';
#printf("writemap: $p $s basedir=%s baseurl=%s\n",$basedir,$baseurl);
	$mapcount++;
	if ($mapnum!=(int) ($mapcount/50000)) {
		if ($maphandle!=null) {
			fprintf($maphandle,"</urlset>");
			fclose($maphandle);
		}
		$mapnum=(int) ($mapcount/50000);
		$mapname=sprintf('%s%d.xml.gz',$basename,$mapnum);
		$maphandle=gzopen($mapname,"w");
		if ($maphandle===false)
			exit(3);
		
		$maps[]=array($mapname,gmdate('Y-m-d\TH:i:sP'));
		fprintf($maphandle,"%s\n",$hdr);
	}
	fprintf($maphandle,"<url>\n <loc>%s%s</loc>\n <lastmod>%s</lastmod>\n</url>\n",htmlspecialchars($baseurl),htmlspecialchars(substr($p,strlen($basedir.'/'))),gmdate('Y-m-d\TH:i:sP',$s['mtime']));
	#printf("%s%s",$baseurl,substr($p,strlen($basedir.'/')));
	#echo "\n";
}
function rundir($path,$base,$ignore) {
	global $filters;
	if (!is_dir($path)) 
		return null;
	
	$mih=@fopen("$path/.mapignore",'r');
	if ($mih!==false) {
		while ($il=fgets($mih)) {$ignore[]=trim($il);}
		fclose($mih);
	}

	$dh=@opendir($path);
	if ($dh===false) return;

	while (($file = readdir($dh)) !== false) {
		if (substr($file,0,1)=='.') continue;
		
		foreach ($filters as $f) {
			if (fnmatch($f[2],"$path/$file")) {
				#printf("%s ignored %s\n","$path/$file",$f[2]);
				#print_r($f);
				continue 2;
			}
		}

		foreach ($ignore as $pat) {
			if (preg_match($pat,"$path/$file")==1) {
				$skp=true;
				continue 2;
			}
		}

		$s=stat("$path/$file");

		#if (substr($file,strlen($file)-5)!='.html' && is_dir("$path/$file")) { can't do this, we need file date

		if (($s['mode'] & 0170000) == 040000) { // is it a dir?
			writemap("$path/$file/",$s);
			rundir("$path/$file","$base/$file",$ignore);
		} else {
			writemap("$path/$file",$s);
			#echo "$path/$file\n";
		}
	}
}

foreach ($dirs as $d) {
	$basedir=$d[0];
	$baseurl=$d[1];
	rundir($basedir,$baseurl,$ignore);
}

if ($maphandle!=null)
	fprintf($maphandle,"</urlset>");

if ($mapnum>0) {
	$idx=sprintf("%s_index.xml",$basename);
	$ping=$mapurl.basename($idx);

	$ih=fopen($idx,'w');
	fprintf($ih,'<?xml version="1.0" encoding="UTF-8"?>
<sitemapindex
  xmlns="http://www.google.com/schemas/sitemap/0.84"
  xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
  xsi:schemaLocation="http://www.google.com/schemas/sitemap/0.84
                      http://www.google.com/schemas/sitemap/0.84/siteindex.xsd">');
	fprintf($ih,"\n");
	foreach ($maps as $m) {
		fprintf($ih," <sitemap>\n  <loc>%s%s</loc>\n  <lastmod>%s</lastmod>\n </sitemap>\n",
			$mapurl,basename($m[0]),$m[1]);
	}
	fprintf($ih,"</sitemapindex>");
	fclose($ih);
} else {
	$ping=sprintf('%s%s%d.xml.gz',$mapurl,basename($basename),0);
}

# ping search engines to let them know about the sitemap update

if ($ping_google_after_generate) {
    $ping_base_url = "http://www.google.com/webmasters/sitemaps/ping?sitemap=";
    file_get_contents($ping_base_url.urlencode($ping));
    $ping_base_url = "http://www.bing.com/webmaster/ping.aspx?sitemap=";
    file_get_contents($ping_base_url.urlencode($ping));
    $ping_base_url = "http://submissions.ask.com/ping?sitemap=";
    file_get_contents($ping_base_url.urlencode($ping));
    $ping_base_url = "http://api.moreover.com/ping?u=";
    file_get_contents($ping_base_url.urlencode($ping));
	
# you have to signup and get an ID to ping yahoo

	if (strlen($yahooid))>0) {
    	$ping_base_url = "http://search.yahooapis.com/SiteExplorerService/V1/updateNotification?appid=$yahooid&url=";
    	file_get_contents($ping_base_url.urlencode($ping));
	}

}

